import React, { useEffect } from 'react';
import UTIF from 'utif';
import axios from 'axios';

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

var styles = {"container":"_1Lxpd","button":"_2hTXI","span":"_2yRPI"};

var _excluded = ["tiff"];
var TIFFViewer = function TIFFViewer(_ref) {
  var displayTIFF = function displayTIFF(tiffUrl) {
    try {
      return Promise.resolve(axios.get(tiffUrl, {
        responseType: 'arraybuffer'
      })).then(function (response) {
        imgLoaded({
          target: {
            response: response.data
          }
        });
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var tiff = _ref.tiff,
    rest = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _React$useState = React.useState(tiff),
    _tiff = _React$useState[0];
  var _React$useState2 = React.useState([]),
    setTiffs = _React$useState2[1];
  var _React$useState3 = React.useState([]),
    pages = _React$useState3[0],
    setPages = _React$useState3[1];
  var _React$useState4 = React.useState(0),
    page = _React$useState4[0],
    setPage = _React$useState4[1];
  function imgLoaded(e) {
    var ifds = UTIF.decode(e.target.response);
    var _tiffs = ifds.map(function (ifd, index) {
      UTIF.decodeImage(e.target.response, ifd);
      var rgba = UTIF.toRGBA8(ifd);
      var canvas = document.createElement('canvas');
      canvas.width = ifd.width;
      canvas.height = ifd.height;
      var ctx = canvas.getContext('2d');
      var img = ctx.createImageData(ifd.width, ifd.height);
      img.data.set(rgba);
      ctx.putImageData(img, 0, 0);
      if (index === 0) document.getElementById('tiff-inner-container').appendChild(canvas);
      return canvas;
    });
    setPages(_tiffs);
    setTiffs(_tiffs);
  }
  var handlePreviousClick = function handlePreviousClick() {
    if (page > 0) {
      setPage(page - 1);
    }
  };
  var handleNextClick = function handleNextClick() {
    if (page < pages.length - 1) {
      setPage(page + 1);
    }
  };
  useEffect(function () {
    displayTIFF(_tiff);
  }, [_tiff]);
  useEffect(function () {
    if (pages.length > 0) {
      var tiffInnerContainer = document.getElementById('tiff-inner-container');
      tiffInnerContainer.innerHTML = '';
      tiffInnerContainer.appendChild(pages[page]);
    }
  }, [page, pages]);
  return /*#__PURE__*/React.createElement("div", _extends({
    className: styles.container,
    id: "tiff-container"
  }, rest), /*#__PURE__*/React.createElement("div", {
    id: "tiff-inner-container"
  }), pages.length > 1 && /*#__PURE__*/React.createElement("div", {
    id: "footer"
  }, /*#__PURE__*/React.createElement("button", {
    disabled: page === 0,
    onClick: handlePreviousClick,
    className: styles.button
  }, "Previous"), /*#__PURE__*/React.createElement("span", {
    className: styles.span
  }, "Page ", page + 1, " of ", pages.length), /*#__PURE__*/React.createElement("button", {
    disabled: page === pages.length - 1,
    onClick: handleNextClick,
    className: styles.button
  }, "Next")));
};

export { TIFFViewer };
//# sourceMappingURL=index.modern.js.map
